<template>
	<div class="control-userLastTable wow fadeInUp">
		<div class="text-bold">{{ $t('users.tickets.title') }}</div>
		<div class="table-header">
			<div class="table-header--left">
				<div class="text-id">{{ $t('users.tickets.id') }}</div>
				<div class="text-id">{{ $t('users.tickets.last_message') }}</div>
			</div>
			<div class="table-header-center">
				<p class="text-id">{{ $t('users.tickets.subject') }}</p>
			</div>
			<div class="table-header--right">
				<p class="text-id">{{ $t('users.tickets.status') }}</p>
				<p class="text-id">{{ $t('users.tickets.edit') }}</p>
			</div>
		</div>
		<div class="table-bodyElement" v-for="ticket in tickets">
			<div class="table-bodyElement--left">
				<p class="text-idBoldBlue">#{{ ticket.id }}</p>
				<p class="text-id">{{ ticket.last_message_at | formatDate }}</p>
			</div>
			<div class="table-bodyElement-center">
				<p class="text-id">{{ ticket.subject }}</p>
			</div>
			<div class="table-bodyElement--right">
				<p class="text-idBlue">{{ ticket.read ? $t('users.messages.status_read') : $t('users.messages.status_unread') }}</p>
				<div class="box-iconRight">
					<a href="#" @click.prevent="deleteTicket(ticket.id)">
						<svg class="deleteIcon">
							<use xlink:href="/img/sprite.svg#cancel-button"/>
						</svg>
					</a>
					<router-link :to="route('tickets_show', {id: ticket.id})">
						<svg class="editIcon">
							<use xlink:href="/img/sprite.svg#edit"/>
						</svg>
					</router-link>
				</div>
			</div>
		</div>
		<paginator
			:current-page="currentPage"
			:last-page="lastPage"
			:per-page="perPage"
			:items-count="total"
			@page-changed="setPage"
		/>
	</div>
</template>

<script>
import route from "Admin/mixins/route";
import {mapGetters} from "vuex";
import dayjs from "dayjs";

export default {
	name: "ShortTickets",
	mixins: [route],
	props: ['user'],
	data(){
		return {
			currentPage: 0,
			lastPage: 0,
			perPage: 0,
			total: 0,
			page: 1,
			tickets: [],
		}
	},
	computed: {
		...mapGetters([
			'axios'
		])
	},
	methods: {
		submit(){
			this.axios.get(`users/${this.user.id}/short_tickets`, {
				params: {
					page: this.page,
				}
			})
				.then(resp => resp.data)
				.then(tickets => {
					console.log(tickets);
					this.currentPage = tickets.current_page;
					this.lastPage = tickets.last_page;
					this.perPage = tickets.per_page;
					this.total = tickets.total;
					this.tickets = tickets.data;
				});
		},
		deleteTicket(id){
			this.axios
				.post(`tickets/${id}/delete`)
				.then(resp => resp.data)
				.then(data => {
					if('success' === data.status){
						this.$swal('Сообщение удалено');
						this.$root.$emit('reload-messages')
					}else{
						this.$swal(this.$t('ui.error'), '', 'error')
					}
				});
		},
		setPage(page){
			this.page = page;
			this.submit();
		},
	},
	filters: {
		formatDate(value) {
			return dayjs(value).format('YYYY.MM.DD HH:mm');
		}
	},
	mounted(){
		this.submit();
		this.$root.$on('reload-tickets', () => {
			this.setPage(1);
		});
		this.$root.$on('reload-messages', () => {
			this.setPage(1);
		});
	},
}
</script>

<style scoped>
.control-userLastTable .table-bodyElement .table-bodyElement-center{
	overflow: visible;
}
</style>
